#!/bin/env python3
# convert minstance file to multiple visualization tracks

import sys;
import argparse;
from MInstClass import *;
import pdb;



parser=argparse.ArgumentParser(description='Convert minstance to multiple visualization tracks');

parser.add_argument('-n','--output-prefix',type=str,help='The prefix of the output file. Default is given minstfile.',default='');
parser.add_argument('minstfile',type=argparse.FileType('r'));

args=parser.parse_args();

if args.output_prefix == '':
  args.output_prefix=args.minstfile.name;

# output bed track to visualize segments, and bed record of normalized read count
segbedfilename=args.output_prefix+'_segs.bed';
segbedfile=open(segbedfilename,'w');
segcountfile=open(args.output_prefix+'_segs.txt','w');
pairsplicingfile=open(args.output_prefix+'_splicing_pairs.txt','w');

thisminst=MInstClass();

while thisminst.readFromFile(args.minstfile) != -1:
  thisminst.segToBed(segbedfile);
  thisminst.segNormalizedCntToFile(segcountfile);
  
  # test: defining splicing pairs
  # print('Inst'+thisminst.instid+' splice map:');
  # for ci in thisminst.splicemap:
  #   print(' '.join([(lambda t: str(1) if t>0 else '0')(x) for x in ci]));
  # print('Test pairs:');
  # gp=thisminst.getTestPairs();
  # for (k,v) in gp.items():
  #   print(str(k)+':'+str(v));
  # debug: connnectivity map
  # cmp=thisminst.getConnMap();
  # print('Inst'+thisminst.instid+' connectivity map:');
  # for ci in cmp:
  #   print(' '.join(str(ci)));
  thisminst.pairSplicingToBed(pairsplicingfile);

pairsplicingfile.close();
segbedfile.close();
segcountfile.close();




