#include <iostream>
#include <fstream>
#include "mfileio.h"

double REPORT_EXPCUTOFF=-1.0;
double SINGLETONCUTOFF=1.0; //exp cut off for single-exon gene

int predToStream(ostream & ofs,ostream& ofexps,MInst& inst, mi& res, md& explv,  vi& direction){
  ml & segs=inst.segment;
  vd exp;
  exp.resize(res.size());
  //calculate the mean value
  for(int i=0;i<res.size();i++){
    exp[i]=getVectorSum<double>(explv[i])/explv[i].size();
  }

  for(int ii=0;ii<res.size();ii++){
    if(res[ii].size()==0)continue;
    if(exp[ii]<=REPORT_EXPCUTOFF)continue;
    
    //write to explv file
    ofexps<<ii<<"\t"<<inst.id<<"_"<<ii;
    for(int jj=0;jj<explv[ii].size();jj++) ofexps<<"\t"<<explv[ii][jj]; ofexps<<endl;
    //write to pred file
    vl allp1,allp2;
    //merging segments
    for(int jj=0;jj<res[ii].size();jj++){
      int id=res[ii][jj];
      if(allp1.size()==0 || segs[id][0]!=allp2.back()+1) {
        allp1.push_back(segs[id][0]);
        allp2.push_back(segs[id][1]);
      }else{
        allp2.back()=segs[id][1];
      }
    }
    if(allp1.size()==1 && exp[ii]<=SINGLETONCUTOFF)continue;
    //writing
    ofs<<ii<<"\t"<<inst.id<<"_"<<ii<<"\t";
    ofs<<inst.chrname<<"\t";
    if(direction[ii]>=0)
      ofs<<"+\t";
    else
      ofs<<"-\t";
    ofs<<allp1.front()-1<<"\t"<<allp2.back()<<"\t";
    for(int i=0;i<allp1.size();i++){
      ofs<<allp1[i]-1;
      if(i!=allp1.size()-1)ofs<<",";
    }
    ofs<<"\t";
    for(int i=0;i<allp2.size();i++){
      ofs<<allp2[i];
      if(i!=allp2.size()-1)ofs<<",";
    }
    ofs<<"\t"<<exp[ii]<<endl;
  }
  return 0;
}

int predToFile(const char* filename,MInst& inst, mi& res, vd& exp,vi& direction){
  ofstream ofs(filename);
 
  if(!ofs.is_open()){
    cerr<<"Error opening file "<<filename<<endl;
    return -1;
  }
  //predToStream(ofs,inst,res,explv,direction);

  ofs.close();
  return 0;
}
 
